edu.sc.seis.sod.process.waveform.vector

## Class IterDeconReceiverFunction

- java.lang.Object
- - edu.sc.seis.sod.process.waveform.vector.AbstractWaveformVectorMeasure
  - - edu.sc.seis.sod.process.waveform.vector.IterDeconReceiverFunction

- All Implemented Interfaces:
    WaveformVectorProcess, SodElement, Subsetter

      public class IterDeconReceiverFunction
      extends AbstractWaveformVectorMeasure

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static float` | `DEFAULT_GWIDTH`
    `static int` | `DEFAULT_MAXBUMPS`
    `static edu.iris.Fissures.model.TimeInterval` | `DEFAULT_SHIFT`
    `static float` | `DEFAULT_TOL`
    `protected float` | `gwidth`
    `protected int` | `maxBumps`
    `protected java.lang.String` | `modelName`
    `protected float` | `orientationTol`
    `protected edu.iris.Fissures.model.TimeInterval` | `pad`
    `protected boolean` | `pWave`
    `protected edu.iris.Fissures.model.TimeInterval` | `shift`
    `protected edu.sc.seis.fissuresUtil.bag.TauPUtil` | `taup`
    `protected float` | `tol`
    `protected AbstractSeismogramWriter` | `writer`

    - ### Fields inherited from class edu.sc.seis.sod.process.waveform.vector.AbstractWaveformVectorMeasure

      `name`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IterDeconReceiverFunction(org.w3c.dom.Element config)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static edu.iris.Fissures.model.TimeInterval` | `getDefaultShift()`
    `float` | `getGwidth()`
    `int` | `getMaxBumps()`
    `edu.iris.Fissures.model.TimeInterval` | `getPad()`
    `edu.iris.Fissures.model.TimeInterval` | `getShift()`
    `float` | `getTol()`
    `boolean` | `isOverwrite()`
    `boolean` | `ispWave()`
    `boolean` | `isThreadSafe()`
    `void` | `parseIterDeconConfig(org.w3c.dom.Element config)`
    `edu.sc.seis.fissuresUtil.bag.IterDeconResult[]` | `process(edu.iris.Fissures.IfEvent.EventAccessOperations event, edu.sc.seis.fissuresUtil.hibernate.ChannelGroup channelGroup, edu.iris.Fissures.seismogramDC.LocalSeismogramImpl[] localSeis)`
    `edu.sc.seis.fissuresUtil.bag.IterDeconResult` | `processComponent(float[] component, float[] zdata, float period, edu.iris.Fissures.Location staLoc, edu.iris.Fissures.IfEvent.Origin origin)`
    `edu.iris.Fissures.seismogramDC.LocalSeismogramImpl` | `saveTimeSeries(float[] data, java.lang.String name, java.lang.String chanCode, edu.iris.Fissures.model.MicroSecondDate begin, edu.iris.Fissures.seismogramDC.LocalSeismogramImpl refSeismogram, edu.iris.Fissures.model.UnitImpl unit, edu.iris.Fissures.Orientation orientation, edu.sc.seis.fissuresUtil.cache.CacheEvent event, edu.sc.seis.fissuresUtil.hibernate.ChannelGroup channelGroup, edu.iris.Fissures.IfSeismogramDC.RequestFilter[][] original, edu.iris.Fissures.IfSeismogramDC.RequestFilter[][] available, CookieJar cookieJar)`

    - ### Methods inherited from class edu.sc.seis.sod.process.waveform.vector.AbstractWaveformVectorMeasure

      `accept, getName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_GWIDTH

          public static float DEFAULT_GWIDTH

    - #### DEFAULT_MAXBUMPS

          public static int DEFAULT_MAXBUMPS

    - #### DEFAULT_TOL

          public static float DEFAULT_TOL

    - #### orientationTol

          protected float orientationTol

    - #### gwidth

          protected float gwidth

    - #### tol

          protected float tol

    - #### maxBumps

          protected int maxBumps

    - #### modelName

          protected java.lang.String modelName

    - #### pWave

          protected boolean pWave

    - #### shift

          protected edu.iris.Fissures.model.TimeInterval shift

    - #### pad

          protected edu.iris.Fissures.model.TimeInterval pad

    - #### writer

          protected AbstractSeismogramWriter writer

    - #### DEFAULT_SHIFT

          public static final edu.iris.Fissures.model.TimeInterval DEFAULT_SHIFT

    - #### taup

          protected edu.sc.seis.fissuresUtil.bag.TauPUtil taup

  - ### Constructor Detail

    - #### IterDeconReceiverFunction

          public IterDeconReceiverFunction(org.w3c.dom.Element config)
                                    throws ConfigurationException,
                                           edu.sc.seis.TauP.TauModelException

      Throws:
        `ConfigurationException`
        `edu.sc.seis.TauP.TauModelException`

  - ### Method Detail

    - #### parseIterDeconConfig

          public void parseIterDeconConfig(org.w3c.dom.Element config)
                                    throws ConfigurationException

      Throws:
        `ConfigurationException`

    - #### process

          public edu.sc.seis.fissuresUtil.bag.IterDeconResult[] process(edu.iris.Fissures.IfEvent.EventAccessOperations event,
                                                                        edu.sc.seis.fissuresUtil.hibernate.ChannelGroup channelGroup,
                                                                        edu.iris.Fissures.seismogramDC.LocalSeismogramImpl[] localSeis)
                                                                 throws edu.iris.Fissures.IfEvent.NoPreferredOrigin,
                                                                        edu.iris.Fissures.FissuresException,
                                                                        edu.sc.seis.fissuresUtil.bag.IncompatibleSeismograms,
                                                                        edu.sc.seis.TauP.TauModelException,
                                                                        edu.sc.seis.fissuresUtil.bag.ZeroPowerException

      Throws:
        `edu.iris.Fissures.IfEvent.NoPreferredOrigin`
        `edu.iris.Fissures.FissuresException`
        `edu.sc.seis.fissuresUtil.bag.IncompatibleSeismograms`
        `edu.sc.seis.TauP.TauModelException`
        `edu.sc.seis.fissuresUtil.bag.ZeroPowerException`

    - #### processComponent

          public edu.sc.seis.fissuresUtil.bag.IterDeconResult processComponent(float[] component,
                                                                               float[] zdata,
                                                                               float period,
                                                                               edu.iris.Fissures.Location staLoc,
                                                                               edu.iris.Fissures.IfEvent.Origin origin)
                                                                        throws edu.sc.seis.TauP.TauModelException,
                                                                               edu.sc.seis.fissuresUtil.bag.ZeroPowerException

      Throws:
        `edu.sc.seis.TauP.TauModelException`
        `edu.sc.seis.fissuresUtil.bag.ZeroPowerException`

    - #### saveTimeSeries

          public edu.iris.Fissures.seismogramDC.LocalSeismogramImpl saveTimeSeries(float[] data,
                                                                                   java.lang.String name,
                                                                                   java.lang.String chanCode,
                                                                                   edu.iris.Fissures.model.MicroSecondDate begin,
                                                                                   edu.iris.Fissures.seismogramDC.LocalSeismogramImpl refSeismogram,
                                                                                   edu.iris.Fissures.model.UnitImpl unit,
                                                                                   edu.iris.Fissures.Orientation orientation,
                                                                                   edu.sc.seis.fissuresUtil.cache.CacheEvent event,
                                                                                   edu.sc.seis.fissuresUtil.hibernate.ChannelGroup channelGroup,
                                                                                   edu.iris.Fissures.IfSeismogramDC.RequestFilter[][] original,
                                                                                   edu.iris.Fissures.IfSeismogramDC.RequestFilter[][] available,
                                                                                   CookieJar cookieJar)
                                                                            throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### getGwidth

          public float getGwidth()

    - #### getTol

          public float getTol()

    - #### getMaxBumps

          public int getMaxBumps()

    - #### ispWave

          public boolean ispWave()

    - #### getShift

          public edu.iris.Fissures.model.TimeInterval getShift()

    - #### getPad

          public edu.iris.Fissures.model.TimeInterval getPad()

    - #### isOverwrite

          public boolean isOverwrite()

    - #### getDefaultShift

          public static edu.iris.Fissures.model.TimeInterval getDefaultShift()

    - #### isThreadSafe

          public boolean isThreadSafe()